> For the complete documentation index, see [llms.txt](https://docs.payments.thalescloud.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payments.thalescloud.io/push-provisioning/implement-push-provisioning/implement-view-and-control/in-app-authentication-for-visa-ctf/approve-binding-or-cardholder-verification-request.md).

# Approve binding or cardholder verification request

### Approve binding

To approve a device binding request, call `DigitalCardService.approveBinding` with `digitalCardID` and `bindingReference`.

The following examples show how to approve a binding request.

{% tabs %}
{% tab title="Android" %}

```kotlin
val digitalCardID = "" // tokenReferenceID from payload
val bindingReference = "" // deviceIndex from payload
val reason: DigitalCardService.BindingApprovalReason? =
    DigitalCardService.BindingApprovalReason.USER_DECISION // optional; null defaults to ISSUER_DECISION

d1Task.digitalCardService().approveBinding(
    digitalCardID,
    bindingReference,
    reason,
    object : D1Task.Callback<Void> {
        override fun onSuccess(data: Void?) {
            // Handle success.
        }

        override fun onError(e: D1Exception) {
            // Handle error.
        }
    }
)
```

```java
String digitalCardID = ""; // tokenReferenceID from payload
String bindingReference = ""; // deviceIndex from payload
DigitalCardService.BindingApprovalReason reason =
        DigitalCardService.BindingApprovalReason.USER_DECISION; // optional; null defaults to ISSUER_DECISION

d1Task.digitalCardService().approveBinding(
        digitalCardID,
        bindingReference,
        reason,
        new D1Task.Callback<Void>() {
            @Override
            public void onSuccess(Void data) {
                // Handle success.
            }

            @Override
            public void onError(@NonNull D1Exception exception) {
                // Handle error.
            }
        });
```

{% endtab %}

{% tab title="iOS" %}

```swift
do {
    let digitalCardID = "" // tokenReferenceID from payload
    let bindingReference = "" // deviceIndex from payload

    try await d1Task.digitalCardService().approveBinding(digitalCardID, bindingReference: bindingReference, reason: nil)
} catch let error {
    // Handle the error.
}
```

{% endtab %}
{% endtabs %}

### Approve cardholder verification

To approve a cardholder verification request, call `DigitalCardService.approveCardholderVerification` with `digitalCardID`.

The following examples show how to approve a cardholder verification request.

{% tabs %}
{% tab title="Android" %}

```kotlin
val digitalCardID = "" // obtained from VISA CTF
val reason: DigitalCardService.VerificationReason? = null // optional; null defaults to ISSUER_DECISION

d1Task.digitalCardService().approveCardholderVerification(
    digitalCardID,
    reason,
    object : D1Task.Callback<Void> {
        override fun onSuccess(data: Void?) {
            // Handle success.
        }

        override fun onError(e: D1Exception) {
            // Handle error.
        }
    }
)
```

```java
String digitalCardID = ""; // obtained from VISA CTF
DigitalCardService.VerificationReason reason = null; // optional; null defaults to ISSUER_DECISION

d1Task.digitalCardService().approveCardholderVerification(
        digitalCardID,
        reason,
        new D1Task.Callback<Void>() {
            @Override
            public void onSuccess(Void data) {
                // Handle success.
            }

            @Override
            public void onError(@NonNull D1Exception exception) {
                // Handle error.
            }
        });
```

{% endtab %}

{% tab title="iOS" %}

```swift
do {
    let digitalCardID = "" // obtained from VISA CTF
    try await d1Task.digitalCardService().approveCardholderVerification(digitalCardID, reason: nil)
} catch let error {
    // Handle the error.
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.payments.thalescloud.io/push-provisioning/implement-push-provisioning/implement-view-and-control/in-app-authentication-for-visa-ctf/approve-binding-or-cardholder-verification-request.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
